<!--
 - Created by MarosGrajcar on 1/15/2020.
 -->

<!-- Eqt Add Transfer Forms -->
<template>
    <template if:true={loading}>
        <lightning-spinner class="slds-is-relative slds-align--absolute-center slds-p-around--small"
                           alternative-text="Loading" size="medium"></lightning-spinner>
    </template>
    <template if:false={loading}>

        <div class="slds-card slds-p-around--small">
            <lightning-icon icon-name="custom:custom19"></lightning-icon>
            <span class="slds-text-title_caps slds-p-left--x-small">
                <b>Add Equipment Forms</b>
            </span>
        </div>

        <div if:false={addFormsEmpty} class="slds-p-around--small slds-scrollable">
            <table class="slds-table slds-table_bordered slds-table_cell-buffer slds-card">
                <thead>
                <tr class="slds-text-title_caps">
                    <th scope="col">
                        Action
                    </th>
                    <th scope="col">
                        Name
                    </th>
                    <th scope="col">
                        Form Status
                    </th>
                    <th scope="col">
                        Equipment Status
                    </th>
                    <th scope="col">
                        Manufacturer
                    </th>
                    <th scope="col">
                        Manufacturer Serial No
                    </th>
                    <th scope="col">
                        Model Number
                    </th>
                    <th scope="col">
                        Tag Number
                    </th>
                    <th scope="col">
                        Created By
                    </th>

                </tr>
                </thead>

                <tbody>

                <template for:each={addForms} for:item="addForm">
                    <tr class="slds-hint-parent slds-card" key={addForm.Id}>

                        <th scope="row">
                            <lightning-button-icon class="slds-align-content-center slds-p-left--small"
                                                   icon-name="utility:edit"
                                                   data-id={addForm.Id}
                                                   size="small"
                                                   onclick={openAddEquipmentModal}>
                            </lightning-button-icon>
                        </th>

                        <td>
                            <a onclick={navigateToAddFormRecord} data-id={addForm.Id}>{addForm.Name}</a>
                        </td>

                        <td>
                            {addForm.Status__c}
                        </td>

                        <td>
                            {addForm.Equipment_Status__c}
                        </td>

                        <td>
                            {addForm.Manufacturer__c}
                        </td>

                        <td>
                            {addForm.Manufacturer_Serial_No__c}
                        </td>

                        <td>
                            {addForm.Model_Number__c}
                        </td>

                        <td>
                            {addForm.Tag_Number__c}
                        </td>

                        <td>
                            <a onclick={navigateToUser} data-userid={addForm.CreatedById}>{addForm.CreatedBy.Name}</a>
                            <lightning-formatted-date-time class="slds-p-left--small"
                                                           value={addForm.CreatedDate}
                                                           year="numeric"
                                                           month="short"
                                                           day="2-digit">
                            </lightning-formatted-date-time>
                        </td>

                    </tr>
                </template>
                </tbody>

            </table>

        </div>

        <div if:true={addFormsEmpty} class="slds-p-around--small slds-text-title_caps">
            <b>NO RECORDS TO DISPLAY</b>
        </div>
    </template>

    <template if:false={loading}>

        <div class="slds-card slds-p-around--small">
            <lightning-icon icon-name="custom:custom19"></lightning-icon>
            <span class="slds-text-title_caps slds-p-left--x-small">
                <b>Equipment Transfer Forms (TO Destination)</b>
            </span>
        </div>

        <div if:false={transferTOFormsEmpty} class="slds-p-around--small slds-scrollable">
            <table class="slds-table slds-table_bordered slds-table_cell-buffer slds-card">
                <thead>
                <tr class="slds-text-title_caps">
                    <th scope="col">
                        Action
                    </th>
                    <th scope="col">
                        Name
                    </th>
                    <th scope="col">
                        TO (Destination)
                    </th>
                    <th scope="col">
                        Form Status
                    </th>
                    <th scope="col">
                        Reason for Transfer
                    </th>
                    <th scope="col">
                        Date of Physical Transfer
                    </th>
                    <th scope="col">
                        Authorized By
                    </th>
                    <th scope="col">
                        Shipped Via
                    </th>
                    <th scope="col">
                        Waybill No
                    </th>
                    <th>
                        CreatedBy
                    </th>

                </tr>
                </thead>

                <tbody>

                <template for:each={transferTOForms} for:item="transferTo">
                    <tr class="slds-hint-parent slds-card" key={transferTo.Id}>

                        <th scope="row">
                            <lightning-button-icon class="slds-align-content-center"
                                                   icon-name="utility:edit"
                                                   data-id={transferTo.Id}
                                                   size="small"
                                                   onclick={openTransferModal}>
                            </lightning-button-icon>
                        </th>

                        <td>
                            <a onclick={navigateToTransferFormRecord} data-id={transferTo.Id}>{transferTo.Name}</a>
                        </td>

                        <td>
                            {transferTo.TO_Destination__c}
                        </td>

                        <td>
                            {transferTo.Status__c}
                        </td>

                        <td>
                            {transferTo.Reason_for_Transfer_Additional_Details__c}
                        </td>

                        <td>
                            <lightning-formatted-date-time class="slds-p-left--small"
                                                           value={transferTo.Date_of_Physical_Transfer__c}
                                                           year="numeric"
                                                           month="short"
                                                           day="2-digit">
                            </lightning-formatted-date-time>
                        </td>

                        <td>
                            <a onclick={navigateToUser} data-userid={transferTo.Authorized_By__r.Id}>{transferTo.Authorized_By__r.Name}</a>
                        </td>

                        <td>
                            {transferTo.Shipped_Via__c}
                        </td>

                        <td>
                            {transferTo.Waybill_No__c}
                        </td>

                        <td>
                            <a onclick={navigateToUser} data-userid={transferTo.CreatedById}>{transferTo.CreatedBy.Name}</a>
                            <lightning-formatted-date-time class="slds-p-left--small"
                                                           value={transferTo.CreatedDate}
                                                           year="numeric"
                                                           month="short"
                                                           day="2-digit">
                            </lightning-formatted-date-time>
                        </td>

                    </tr>
                </template>
                </tbody>

            </table>

        </div>

        <div if:true={transferTOFormsEmpty} class="slds-p-around--small slds-text-title_caps">
            <b>NO RECORDS TO DISPLAY</b>
        </div>
    </template>

    <template if:false={loading}>

        <div class="slds-card slds-p-around--small">
            <lightning-icon icon-name="custom:custom19"></lightning-icon>
            <span class="slds-text-title_caps slds-p-left--x-small">
                <b>Equipment Transfer Forms (FROM Source)</b>
            </span>
        </div>

        <div if:false={transferFROMFormsEmpty} class="slds-p-around--small slds-scrollable">
            <table class="slds-table slds-table_bordered slds-table_cell-buffer slds-card">
                <thead>
                <tr class="slds-text-title_caps">
                    <th scope="col">
                        Action
                    </th>
                    <th scope="col">
                        Name
                    </th>
                    <th scope="col">
                        From (Source)
                    </th>
                    <th scope="col">
                        To (Destination)
                    </th>
                    <th scope="col">
                       Form Status
                    </th>
                    <th scope="col">
                        Reason for Transfer
                    </th>
                    <th scope="col">
                        Date of Physical Transfer
                    </th>
                    <th scope="col">
                        Authorized By
                    </th>
                    <th scope="col">
                        Shipped Via
                    </th>
                    <th scope="col">
                        Waybill No
                    </th>
                    <th>
                        CreatedBy
                    </th>

                </tr>
                </thead>

                <tbody>

                <template for:each={transferFROMForms} for:item="transferFrom">
                    <tr class="slds-hint-parent slds-card" key={transferFrom.Id}>

                        <th scope="row">
                            <lightning-button-icon class="slds-align-content-center"
                                                   icon-name="utility:edit"
                                                   data-id={transferFrom.Id}
                                                   size="small"
                                                   onclick={openTransferModal}>
                            </lightning-button-icon>
                        </th>

                        <td>
                            <a onclick={navigateToTransferFormRecord} data-id={transferFrom.Id}>{transferFrom.Name}</a>
                        </td>

                        <td>
                            {transferFrom.FROM_Source__c}
                        </td>

                        <td>
                            {transferFrom.TO_Destination__c}
                        </td>

                        <td>
                            {transferFrom.Status__c}
                        </td>

                        <td>
                            {transferFrom.Reason_for_Transfer_Additional_Details__c}
                        </td>

                        <td>
                            <lightning-formatted-date-time class="slds-p-left--small"
                                                           value={transferFrom.Date_of_Physical_Transfer__c}
                                                           year="numeric"
                                                           month="short"
                                                           day="2-digit">
                            </lightning-formatted-date-time>
                        </td>

                        <td>
                            <a onclick={navigateToUser} data-userid={transferFrom.Authorized_By__r.Id}>{transferFrom.Authorized_By__r.Name}</a>
                        </td>

                        <td>
                            {transferFrom.Shipped_Via__c}
                        </td>

                        <td>
                            {transferFrom.Waybill_No__c}
                        </td>

                        <td>
                            <a onclick={navigateToUser} data-userid={transferFrom.CreatedById}>{transferFrom.CreatedBy.Name}</a>
                            <lightning-formatted-date-time class="slds-p-left--small"
                                                           value={transferFrom.CreatedDate}
                                                           year="numeric"
                                                           month="short"
                                                           day="2-digit">
                            </lightning-formatted-date-time>
                        </td>

                    </tr>
                </template>
                </tbody>

            </table>

        </div>

        <div if:true={transferFROMFormsEmpty} class="slds-p-around--small slds-text-title_caps">
            <b>NO RECORDS TO DISPLAY</b>
        </div>
    </template>



    <template if:true={openAddFormModal}>
        <section class="slds-modal slds-fade-in-open slds-modal--large">
            <div class="slds-modal__container">
                <header class="slds-modal__header">
                    <template if:true={showButtons}>
                        <button class="slds-button slds-button_icon slds-modal__close" title="Close"
                                onclick={closeAddFormModal}>
                            <lightning-icon icon-name="utility:close" size="medium">
                            </lightning-icon>
                            <span class="slds-assistive-text">Close</span>
                        </button>
                    </template>
                    <h2 class="slds-text-heading_medium slds-hyphenate">Add Equipment Form</h2>
                </header>
                <div class="slds-modal__content slds-p-around_medium">
                    <c-eqt_add_cru form-id={formId} edit-modal="true" onclosemodal={closeAddFormModal}
                                   onenablebuttons={enableButtons}></c-eqt_add_cru>
                </div>
                <footer class="slds-modal__footer slds-text-align--left">
                    <template if:true={showButtons}>
                        <lightning-button label="Submit" variant="brand" onclick={saveAddForm}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={closeAddFormModal}></lightning-button>
                    </template>
                </footer>
            </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

    <template if:true={openTransferFormModal}>
        <section class="slds-modal slds-fade-in-open slds-modal--large">
            <div class="slds-modal__container">
                <header class="slds-modal__header">
                    <template if:true={showButtons}>
                        <button class="slds-button slds-button_icon slds-modal__close" title="Close"
                                onclick={closeTransferFormModal}>
                            <lightning-icon icon-name="utility:close" size="medium">
                            </lightning-icon>
                            <span class="slds-assistive-text">Close</span>
                        </button>
                    </template>
                    <h2 class="slds-text-heading_medium slds-hyphenate">Equipment Transfer Form</h2>
                </header>
                <div class="slds-modal__content slds-p-around_medium">
                    <c-eqt_transfer_cru form-id={formId} edit-modal="true" onclosemodal={closeTransferFormModal}
                                   onenablebuttons={enableButtons}></c-eqt_transfer_cru>
                </div>
                <footer class="slds-modal__footer slds-text-align--left">
                    <template if:true={showButtons}>
                        <lightning-button label="Submit" variant="brand" onclick={saveTransferForm}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={closeTransferFormModal}></lightning-button>
                    </template>
                </footer>
            </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

</template>